import java.util.*;
/**
 * Write a description of class Factura here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Factura
{
    // instance variables - replace the example below with your own
    private Date fecha;
    private int numero;
    private double monto;
    private boolean confirmada=false;
    private boolean pagada=false;
    private List<Detalle> detalle = new ArrayList<Detalle>();

    /**
     * Constructor for objects of class Factura
     */
    public Factura()
    {
        // initialise instance variables
    }

    // setters
    public void setNumero(int n) { if ( !isConfirmada() ) numero=n; }
    private void setMonto(double m) { if ( !isConfirmada() ) monto=m; }
    public void setFecha(Date f) { if ( !isConfirmada() ) fecha=f; }
    // getters
    public boolean isConfirmada() { return confirmada; }
    public boolean isPagada() { return pagada; }
    public int getNumero() { return numero; }
    public double getMonto() { return monto; }
    public Date getFecha() { return fecha; }
    // custom
    public void addDetalle(Detalle d) { if ( !isConfirmada() ) detalle.add(d); }
    public void confirmar() {
        calcular();
        // descontar stock
        // sumar saldo deudor del cliente
        // no se puede modificar
        confirmada=true;
    }
    public void calcular() {
        // calcula el monto de la factura a partir de las lineas de detalle
        double total=0.0;
        /*  FORMA DE ITERACION SIMPLE
        for(Detalle d : detalle) {
            System.out.println("calcular(): Sumo Detalle cantidad:"+d.getCantidad()+" precio:"+d.getPrecio());
            total+=d.getSubTotal();
        }
        */
        /* ITERACION utilizanzo Iterator
        Iterator<Detalle> i = detalle.iterator();
        while(i.hasNext()) {
            Detalle d = i.next();
            System.out.println("calcular(): Sumo Detalle cantidad:"+d.getCantidad()+" precio:"+d.getPrecio());
            total+=d.getSubTotal();
        }
        */
        //ITERACION utilizando metodos de la Interface List get() y metodo de la interface Collection size()
        for(int i=0;i<detalle.size();i++) {
            Detalle d = detalle.get(i);
            System.out.println("calcular(): Sumo Detalle cantidad:"+d.getCantidad()+" precio:"+d.getPrecio());
            total+=d.getSubTotal();
        }
        setMonto(total);
    }
    public void pagar() {
        if ( isConfirmada() && !isPagada()) {
            // restaba saldo deudor del cliente
            pagada=true;
        }
    }
}
