import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

/**
 * Ejemplo de ventana simple
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Login
{
    // instance variables - replace the example below with your own
    // creo coleccion para almacenar alli referencias a componentes que puedan ser utilizadas desde clase LoginController
    private Map<String,JComponent> map = new HashMap<String,JComponent>();
    // PASO 2 CREO REFERENCIAS PARA LOS COMPONENTES
    // PASO 5 CREAR LOS OBJETOS COMPONENTES Y AGREGARLOS AL CONTENEDOR
    private JFrame fr = new JFrame("Bienvenido al Sistema de Facturacion");
    private JButton btnLoggin = new JButton("Login");
    private JButton btnCancel = new JButton("Cancel"); 
    private JLabel lblServidor = new JLabel("Servidor:");
    private JTextField txtServidor = new JTextField("localhost");
    private JLabel lblPuerto = new JLabel("Puerto:");
    private JTextField txtPuerto = new JTextField("3050");
    private JLabel lblBd = new JLabel("Base de Datos:");
    private JTextField txtBd = new JTextField("facturacion.fdb");
    private JLabel lblUsuario = new JLabel("Usuario:");
    private JTextField txtUsuario = new JTextField("sysdba");
    private JLabel lblPwd = new JLabel("Contraseña:");
    private JPasswordField txtPwd = new JPasswordField();
    private JLabel lblRol = new JLabel("Rol:");
    private JTextField txtRol = new JTextField("sysdb");
    private JLabel lblcom = new JLabel("status de la aplicacion/mensajes de error");
    private JPanel pfrm = new JPanel(new SpringLayout());
    private JPanel pbottom = new JPanel();
    private JPanel pbottom1 = new JPanel();
    { // bloque de inicializacion para cargar el map
        map.put("servidor",txtServidor);
        map.put("puerto",txtPuerto);
        map.put("bd",txtBd);
        map.put("usuario",txtUsuario);
        map.put("pwd",txtPwd);
        map.put("rol",txtRol);
    }
    

    /**
     * Constructor for objects of class Login
     */
    public Login() {
        buildGUI();
    }
    /**
     * construye la interfaz grafica
     */
    private void buildGUI() {
        // PASO 1 DISE#O GUI EN PAPEL
        // PASO 3 SELECCIONAR UN CONTENEDOR PARA TODOS LOS COMPONENTES, EN ESTE CASO, fr
        // PASO 4 SELECCIONAR LAYOUT MANAGER PARA CADA CONTENEDOR
        pbottom.setLayout(new GridLayout(2,1));
        pbottom1.setLayout(new GridLayout(1,5));
        
        //Create and populate the panel.
        //asociacion de labels con text fields
        lblServidor.setLabelFor(txtServidor);
        lblPuerto.setLabelFor(txtPuerto);
        lblBd.setLabelFor(txtBd);
        lblUsuario.setLabelFor(txtUsuario);
        lblPwd.setLabelFor(txtPwd);
        lblRol.setLabelFor(txtRol);
        // agrego componentes al contenedor formulario
        pfrm.add(lblServidor);
        pfrm.add(txtServidor);
        pfrm.add(lblPuerto);
        pfrm.add(txtPuerto);
        pfrm.add(lblBd);
        pfrm.add(txtBd);
        pfrm.add(lblUsuario);
        pfrm.add(txtUsuario);
        pfrm.add(lblPwd);
        pfrm.add(txtPwd);
        pfrm.add(lblRol);
        pfrm.add(txtRol);
        
        // PASO 5 CREAR LOS OBJETOS COMPONENTES Y AGREGARLOS AL CONTENEDOR
        pbottom1.add(new JLabel(""));
        pbottom1.add(btnLoggin);
        pbottom1.add(new JLabel(""));
        pbottom1.add(btnCancel);
        pbottom1.add(new JLabel(""));
        pbottom.add(pbottom1);
        pbottom.add(lblcom);
        
        //Lay out the panel.
        SpringUtilities.makeCompactGrid(pfrm,
                                        6, 2, //rows, cols
                                        6, 6, //initX, initY
                                        6, 6);//xPad, yPad
        
        fr.getContentPane().add("Center",pfrm);
        fr.getContentPane().add("South",pbottom);
        // PASO 6 REGISTRAR LOS ESCUCHADORES DE EVENTOS (EVENT LISTENERS) CON LOS COMPONENTES
        LoginController lc = new LoginController(this);
        lc.cargoParametros();  // indico a LoginController que cargue archivo facturacion.properties
        btnLoggin.addActionListener(lc);
        btnCancel.addActionListener(lc);
        fr.addWindowListener(lc);
        
        fr.setLocationRelativeTo(null); // centrado
        // PASO 7 CONFIGURAR EL TAMA#O DEL CONTENEDOR
        fr.setSize(500,400);
        // PASO 8 HACER EL CONTENEDOR VISIBLE
        fr.setVisible(true);
    }

    // GETTERS
    public JComponent getComponente(final String nombreComponente) {
        return map.get(nombreComponente);
    }
    public JFrame getJFrame() { return fr; }
    public JLabel getComentario() { return lblcom; }
    // SETTERS
    // CUSTOMS
    public void cierroAplicacion() {
System.out.println("Login.cierroAplicacion()");        
        // cerrar la conexion a b.d.
        if ( DataIO.isConnected() ) DataIO.finish();
        fr.dispose();
        System.exit(0);
    }
    
    public static void main(String[] arg) {
        new Login();
    }
}
